## hoel 1.1

=== examples/Makefile ===
#
# Example program
#
# Makefile used to build the software
#
# Copyright 2014-2015 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
PREFIX=/usr/local/angharad
CC=gcc
CFLAGS=-c -Wall -D_REENTRANT -I$(PREFIX)/include $(ADDITIONALFLAGS)
HOEL_LOCATION=../src
LIBS=-lc -lhoel -ljansson -lyder -L$(PREFIX)/lib -L$(HOEL_LOCATION)
ADDITIONALFLAGS=-O3

all: libhoel.so example_sqlite3 example_mariadb example_pgsql example_mariadb_json

clean:
	rm -f *.o example_sqlite3 example_mariadb example_pgsql example_mariadb_json

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: libhoel.so example_sqlite3 example_mariadb example_pgsql example_mariadb_json

libhoel.so:
	cd $(HOEL_LOCATION) && $(MAKE) debug

example_sqlite3: example_sqlite3.c
	$(CC) -c $(CFLAGS) example_sqlite3.c
	$(CC) -o example_sqlite3 example_sqlite3.o $(LIBS)

example_mariadb: example_mariadb.c
	$(CC) -c $(CFLAGS) example_mariadb.c
	$(CC) -o example_mariadb example_mariadb.o $(LIBS)

example_pgsql: example_pgsql.c
	$(CC) -c $(CFLAGS) example_pgsql.c
	$(CC) -o example_pgsql example_pgsql.o $(LIBS)

example_mariadb_json: example_mariadb_json.c
	$(CC) -c $(CFLAGS) example_mariadb_json.c
	$(CC) -o example_mariadb_json example_mariadb_json.o $(LIBS)

test: example_sqlite3 example_mariadb example_pgsql
	LD_LIBRARY_PATH=$(HOEL_LOCATION):${LD_LIBRARY_PATH} ./example_pgsql
	LD_LIBRARY_PATH=$(HOEL_LOCATION):${LD_LIBRARY_PATH} ./example_mariadb
	LD_LIBRARY_PATH=$(HOEL_LOCATION):${LD_LIBRARY_PATH} ./example_sqlite3
	LD_LIBRARY_PATH=$(HOEL_LOCATION):${LD_LIBRARY_PATH} ./example_mariadb_json

=== src/Makefile ===
#
# Ulfius Framework
#
# Makefile used to build the software
#
# Copyright 2014-2015 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.	If not, see <http://www.gnu.org/licenses/>.
#
CC=gcc

# uncomment these lines if you want sqlite support
FLAGS_SQLITE=-D_HOEL_SQLITE
LIBS_SQLITE=-lsqlite3

# uncomment these lines if you want sqlite support
FLAGS_MARIADB=-D_HOEL_MARIADB -I/usr/include/mysql/
LIBS_MARIADB=-lmysqlclient

# uncomment these lines if you want sqlite support
# FLAGS_PGSQL=-D_HOEL_PGSQL -I/usr/include/postgresql/
# LIBS_PGSQL=-lpq

PREFIX=/usr/local
CFLAGS=-c -fPIC -Wall -I$(PREFIX)/include $(FLAGS_SQLITE) $(FLAGS_MARIADB) $(FLAGS_PGSQL) -D_REENTRANT $(ADDITIONALFLAGS)
LIBS=-L$(PREFIX)/lib -lc -ljansson -lyder -lorcania $(LIBS_SQLITE) $(LIBS_PGSQL) $(LIBS_MARIADB)
OUTPUT=libhoel.so
VERSION=1.1

all: release

hoel.o: hoel.c hoel.h
	$(CC) $(CFLAGS) hoel.c

hoel-sqlite.o: hoel-sqlite.c hoel.h
	$(CC) $(CFLAGS) hoel-sqlite.c

hoel-mariadb.o: hoel-mariadb.c hoel.h
	$(CC) $(CFLAGS) hoel-mariadb.c

hoel-pgsql.o: hoel-pgsql.c hoel.h
	$(CC) $(CFLAGS) hoel-pgsql.c

hoel-simple-json.o: hoel-simple-json.c hoel.h
	$(CC) $(CFLAGS) hoel-simple-json.c

libhoel.so: hoel-sqlite.o hoel-mariadb.o hoel-pgsql.o hoel-simple-json.o hoel.o
	$(CC) -shared -Wl,-soname,$(OUTPUT) -o $(OUTPUT).$(VERSION) hoel-sqlite.o hoel-mariadb.o hoel-pgsql.o hoel-simple-json.o hoel.o $(LIBS)
	ln -sf $(OUTPUT).$(VERSION) $(OUTPUT)

clean:
	rm -f *.o *.so $(OUTPUT) $(OUTPUT).*

install: all
	cp $(OUTPUT).$(VERSION) $(PREFIX)/lib
	cp hoel.h $(PREFIX)/include
	/sbin/ldconfig -r $(PREFIX)

uninstall:
	rm -f $(PREFIX)/lib/$(OUTPUT)
	rm -f $(PREFIX)/lib/$(OUTPUT).*
	rm -f $(PREFIX)/include/hoel.h

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: libhoel.so

release: ADDITIONALFLAGS=-O3

release: libhoel.so

=== debian/changelog ===
hoel (1.1-1) unstable; urgency=medium

  * Initial release (Closes: #123456)
  * TODO: ITP
  * TODO: debian/copyright

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 18 Jul 2017 14:32:33 +0200

=== debian/control ===
Source: hoel
Section: devel
Priority: optional
Maintainer: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper (>= 10)
	, liborcania-dev
	, libyder-dev
	, libjansson-dev
	, libsqlite3-dev
	, libpq-dev
	, libmariadbclient-dev
Standards-Version: 4.0.0
Homepage: https://github.com/babelouest/yder
#Vcs-Git: https://anonscm.debian.org/collab-maint/oauth2-server.git
#Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/oauth2-server.git

Package: libhoel1.1
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: database abstraction library written in C
 Simple and easy to use database access library. Works with SQLite 3, 
 MariaDB/Mysql and (barely) PostgreSQL databases. Uses a json-based 
 language with jansson to execute simples queries based on one table.

Package: libhoel-dev
Architecture: any
Section: libdevel
Depends: libhoel1.1 (= ${binary:Version})
        , ${misc:Depends}
        , libjansson-dev
	, liborcania-dev
	, libyder-dev
	, libsqlite3-dev
	, libpq-dev
	, libmariadbclient-dev
Description: database abstraction library written in C - development
 Simple and easy to use database access library. Works with SQLite 3, 
 MariaDB/Mysql and (barely) PostgreSQL databases. Uses a json-based 
 language with jansson to execute simples queries based on one table.
 .
 This package contains the development files.

## hoel 1.2.1

=== Makefile ===
#
# Example program
#
# Makefile used to build all programs
#
# Copyright 2014-2015 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU GENERAL PUBLIC LICENSE for more details.
#

LIBHOEL_LOCATION=./src
EXAMPLE_LOCATION=./examples
TEST_LOCATION=./test

all: libhoel.so example_sqlite3 example_mariadb example_pgsql

debug:
	cd $(EXAMPLE_LOCATION) && $(MAKE) debug

install:
	cd $(EXAMPLE_LOCATION) && $(MAKE) install

clean:
	cd $(LIBHOEL_LOCATION) && $(MAKE) clean
	cd $(EXAMPLE_LOCATION) && $(MAKE) clean
	cd $(TEST_LOCATION) && $(MAKE) clean

libhoel.so:
	cd $(LIBHOEL_LOCATION) && $(MAKE)

simple_example:
	cd $(EXAMPLE_LOCATION) && $(MAKE)

example_sqlite3:
	cd $(EXAMPLE_LOCATION) && $(MAKE) example_sqlite3

example_mariadb:
	cd $(EXAMPLE_LOCATION) && $(MAKE) example_mariadb

example_pgsql:
	cd $(EXAMPLE_LOCATION) && $(MAKE) example_pgsql

test:
	cd $(TEST_LOCATION) && $(MAKE) test

=== src/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Ulfius Framework
+# Hoel Framework
 #
 # Makefile used to build the software
 #
@@ -20,23 +20,23 @@
 #
 CC=gcc
 
-# uncomment these lines if you want sqlite support
+# comment/uncomment these lines to disable/enable sqlite3 support
 FLAGS_SQLITE=-D_HOEL_SQLITE
 LIBS_SQLITE=-lsqlite3
 
-# uncomment these lines if you want sqlite support
-FLAGS_MARIADB=-D_HOEL_MARIADB -I/usr/include/mysql/
-LIBS_MARIADB=-lmysqlclient
+# comment/uncomment these lines to disable/enable mysql/mariadb support
+FLAGS_MARIADB=-D_HOEL_MARIADB $(shell mysql_config --cflags)
+LIBS_MARIADB=$(shell mysql_config --libs_r)
 
-# uncomment these lines if you want sqlite support
-# FLAGS_PGSQL=-D_HOEL_PGSQL -I/usr/include/postgresql/
-# LIBS_PGSQL=-lpq
+# comment/uncomment these lines to disable/enable postgresql support
+FLAGS_PGSQL=-D_HOEL_PGSQL -I/usr/include/postgresql/
+LIBS_PGSQL=-lpq
 
 PREFIX=/usr/local
 CFLAGS=-c -fPIC -Wall -I$(PREFIX)/include $(FLAGS_SQLITE) $(FLAGS_MARIADB) $(FLAGS_PGSQL) -D_REENTRANT $(ADDITIONALFLAGS)
 LIBS=-L$(PREFIX)/lib -lc -ljansson -lyder -lorcania $(LIBS_SQLITE) $(LIBS_PGSQL) $(LIBS_MARIADB)
 OUTPUT=libhoel.so
-VERSION=1.1
+VERSION=1.2
 
 all: release
 
@@ -59,16 +59,23 @@
 	$(CC) -shared -Wl,-soname,$(OUTPUT) -o $(OUTPUT).$(VERSION) hoel-sqlite.o hoel-mariadb.o hoel-pgsql.o hoel-simple-json.o hoel.o $(LIBS)
 	ln -sf $(OUTPUT).$(VERSION) $(OUTPUT)
 
+libhoel.a: hoel-sqlite.o hoel-mariadb.o hoel-pgsql.o hoel-simple-json.o hoel.o
+	ar rcs libhoel.a hoel-sqlite.o hoel-mariadb.o hoel-pgsql.o hoel-simple-json.o hoel.o
+
 clean:
-	rm -f *.o *.so $(OUTPUT) $(OUTPUT).*
+	rm -f *.o *.so *.a $(OUTPUT) $(OUTPUT).*
 
 install: all
 	cp $(OUTPUT).$(VERSION) $(PREFIX)/lib
 	cp hoel.h $(PREFIX)/include
-	/sbin/ldconfig -r $(PREFIX)
+	/sbin/ldconfig
+
+static-install: static
+	cp libhoel.a $(PREFIX)/lib
+	cp hoel.h $(PREFIX)/include
 
 uninstall:
-	rm -f $(PREFIX)/lib/$(OUTPUT)
+	rm -f $(PREFIX)/lib/$(OUTPUT) $(PREFIX)/lib/libhoel.a
 	rm -f $(PREFIX)/lib/$(OUTPUT).*
 	rm -f $(PREFIX)/include/hoel.h
 
@@ -79,3 +86,11 @@
 release: ADDITIONALFLAGS=-O3
 
 release: libhoel.so
+
+static-debug: ADDITIONALFLAGS=-DDEBUG -g -O0
+
+static-debug: libhoel.a
+
+static: ADDITIONALFLAGS=-O3
+
+static: libhoel.a

=== debian/changelog ===
hoel (1.2.1-1) unstable; urgency=medium

  * New upstream release
  * debian/control: move to debian-iot group
  * debian/control: bump soname of libhoel to 1.2

 -- Thorsten Alteholz <debian@alteholz.de>  Thu, 05 Oct 2017 19:25:48 +0200

hoel (1.1.2-1) unstable; urgency=medium

  * new upstream version
  * change homepage URL (Closes: #869933)
  * debian/control: bump standard to 4.1.0 (no changes)
  * debian/control: add VCS URLs
  * refresh patches

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 02 Sep 2017 17:17:33 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: hoel
 Section: devel
 Priority: optional
-Maintainer: Thorsten Alteholz <debian@alteholz.de>
+Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
+Uploaders: Thorsten Alteholz <debian@alteholz.de>
 Build-Depends: debhelper (>= 10)
 	, liborcania-dev
 	, libyder-dev
@@ -9,12 +10,12 @@
 	, libsqlite3-dev
 	, libpq-dev
 	, libmariadbclient-dev
-Standards-Version: 4.0.0
-Homepage: https://github.com/babelouest/yder
-#Vcs-Git: https://anonscm.debian.org/collab-maint/oauth2-server.git
-#Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/oauth2-server.git
+Standards-Version: 4.1.0
+Homepage: https://github.com/babelouest/hoel
+Vcs-Browser: https://anonscm.debian.org/cgit/debian-iot/hoel.git
+Vcs-Git: https://anonscm.debian.org/git/debian-iot/hoel.git
 
-Package: libhoel1.1
+Package: libhoel1.2
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -26,7 +27,7 @@
 Package: libhoel-dev
 Architecture: any
 Section: libdevel
-Depends: libhoel1.1 (= ${binary:Version})
+Depends: libhoel1.2 (= ${binary:Version})
         , ${misc:Depends}
         , libjansson-dev
 	, liborcania-dev

## hoel 1.3.1

=== Makefile ===
--- 
+++ 
@@ -32,7 +32,7 @@
 	cd $(TEST_LOCATION) && $(MAKE) clean
 
 libhoel.so:
-	cd $(LIBHOEL_LOCATION) && $(MAKE)
+	cd $(LIBHOEL_LOCATION) && $(MAKE) $(*)
 
 simple_example:
 	cd $(EXAMPLE_LOCATION) && $(MAKE)

=== examples/Makefile ===
--- 
+++ 
@@ -13,11 +13,10 @@
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU GENERAL PUBLIC LICENSE for more details.
 #
-PREFIX=/usr/local/angharad
 CC=gcc
 CFLAGS=-c -Wall -D_REENTRANT -I$(PREFIX)/include $(ADDITIONALFLAGS)
 HOEL_LOCATION=../src
-LIBS=-lc -lhoel -ljansson -lyder -L$(PREFIX)/lib -L$(HOEL_LOCATION)
+LIBS=-lc -lhoel -ljansson -lyder -L$(HOEL_LOCATION)
 ADDITIONALFLAGS=-O3
 
 all: libhoel.so example_sqlite3 example_mariadb example_pgsql example_mariadb_json
@@ -48,8 +47,16 @@
 	$(CC) -c $(CFLAGS) example_mariadb_json.c
 	$(CC) -o example_mariadb_json example_mariadb_json.o $(LIBS)
 
-test: example_sqlite3 example_mariadb example_pgsql
+test: test_pgsql test_mariadb test_sqlite3 test_mariadb_json
+
+test_pgsql: example_pgsql
 	LD_LIBRARY_PATH=$(HOEL_LOCATION):${LD_LIBRARY_PATH} ./example_pgsql
+
+test_mariadb: example_mariadb
 	LD_LIBRARY_PATH=$(HOEL_LOCATION):${LD_LIBRARY_PATH} ./example_mariadb
+
+test_sqlite3: example_sqlite3
 	LD_LIBRARY_PATH=$(HOEL_LOCATION):${LD_LIBRARY_PATH} ./example_sqlite3
+
+test_mariadb_json: example_mariadb_json
 	LD_LIBRARY_PATH=$(HOEL_LOCATION):${LD_LIBRARY_PATH} ./example_mariadb_json

=== src/Makefile ===
--- 
+++ 
@@ -20,23 +20,26 @@
 #
 CC=gcc
 
-# comment/uncomment these lines to disable/enable sqlite3 support
+ifndef DISABLE_SQLITE
 FLAGS_SQLITE=-D_HOEL_SQLITE
 LIBS_SQLITE=-lsqlite3
+endif
 
-# comment/uncomment these lines to disable/enable mysql/mariadb support
+ifndef DISABLE_MARIADB
 FLAGS_MARIADB=-D_HOEL_MARIADB $(shell mysql_config --cflags)
 LIBS_MARIADB=$(shell mysql_config --libs_r)
+endif
 
-# comment/uncomment these lines to disable/enable postgresql support
+ifndef DISABLE_POSTGRESQL
 FLAGS_PGSQL=-D_HOEL_PGSQL -I/usr/include/postgresql/
 LIBS_PGSQL=-lpq
+endif
 
 PREFIX=/usr/local
 CFLAGS=-c -fPIC -Wall -I$(PREFIX)/include $(FLAGS_SQLITE) $(FLAGS_MARIADB) $(FLAGS_PGSQL) -D_REENTRANT $(ADDITIONALFLAGS)
 LIBS=-L$(PREFIX)/lib -lc -ljansson -lyder -lorcania $(LIBS_SQLITE) $(LIBS_PGSQL) $(LIBS_MARIADB)
 OUTPUT=libhoel.so
-VERSION=1.2
+VERSION=1.3.1
 
 all: release

=== test/Makefile ===
#
# Hoel library
#
# Makefile used to build the tests
#
# Copyright 2017 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU GENERAL PUBLIC LICENSE
# License as published by the Free Software Foundation;
# version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

CC=gcc
CFLAGS=-Wall -D_REENTRANT -DDEBUG -g -O0
HOEL_LOCATION=../src
LIBS=-lc -lyder -lhoel -ljansson -lcheck -lpthread -lm -lrt -lsubunit -L$(HOEL_LOCATION)

all: test

clean:
	rm -f *.o core valgrind.txt

libhoel.so:
	cd $(HOEL_LOCATION) && $(MAKE) debug

core: core.c
	$(CC) $(CFLAGS) core.c -o core $(LIBS)

test_core: libhoel.so core
	-LD_LIBRARY_PATH=$(HOEL_LOCATION):${LD_LIBRARY_PATH} ./core

test: test_core

=== debian/changelog ===
hoel (1.3.1-1) unstable; urgency=medium

  * New upstream release
  * debian/control: bump standard to 4.1.3 (no changes)
  * debian/control: use dh11

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 21 Jan 2018 18:31:49 +0100

=== debian/control ===
Source: hoel
Section: devel
Priority: optional
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper (>= 11)
	, liborcania-dev
	, libyder-dev
	, libjansson-dev
	, libsqlite3-dev
	, libpq-dev
	, libmariadbclient-dev
Standards-Version: 4.1.3
Homepage: https://github.com/babelouest/hoel
Vcs-Browser: https://anonscm.debian.org/cgit/debian-iot/hoel.git
Vcs-Git: https://anonscm.debian.org/git/debian-iot/hoel.git

Package: libhoel1.3
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: database abstraction library written in C
 Simple and easy to use database access library. Works with SQLite 3,
 MariaDB/Mysql and (barely) PostgreSQL databases. Uses a json-based
 language with jansson to execute simples queries based on one table.

Package: libhoel-dev
Architecture: any
Section: libdevel
Depends: libhoel1.3 (= ${binary:Version})
        , ${misc:Depends}
        , libjansson-dev
	, liborcania-dev
	, libyder-dev
	, libsqlite3-dev
	, libpq-dev
	, libmariadbclient-dev
Description: database abstraction library written in C - development
 Simple and easy to use database access library. Works with SQLite 3,
 MariaDB/Mysql and (barely) PostgreSQL databases. Uses a json-based
 language with jansson to execute simples queries based on one table.
 .
 This package contains the development files.

## hoel 1.4.2

=== CMakeLists.txt ===
#
# Hoel library
#
# CMake file used to build all programs
#
# Copyright 2018 Nicolas Mora <mail@babelouest.org>
# Copyright 2018 Silvio Clecio <silvioprog@gmail.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#

cmake_minimum_required(VERSION 3.5)

project(hoel C)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror")

# library info

set(PROJECT_DESCRIPTION "C Database abstraction library with json based language")
set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/hoel/issues")

set(LIBRARY_VERSION_MAJOR "1")
set(LIBRARY_VERSION_MINOR "4")
set(LIBRARY_VERSION_PATCH "2")
set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(LIBRARY_SOVERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")
set(YDER_VERSION_DOWNLOAD "1.3.3")

# cmake modules

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)

include(GNUInstallDirs)
include(CheckSymbolExists)

# check if _GNU_SOURCE is available

if (NOT _GNU_SOURCE)
    check_symbol_exists(__GNU_LIBRARY__ "features.h" _GNU_SOURCE)

    if (NOT _GNU_SOURCE)
        unset(_GNU_SOURCE CACHE)
        check_symbol_exists(_GNU_SOURCE "features.h" _GNU_SOURCE)
    endif ()
endif ()

if (_GNU_SOURCE)
    add_definitions(-D_GNU_SOURCE)
endif ()

# directories and source

set(INC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)

include_directories(${INC_DIR})

set(LIB_SRC
        ${INC_DIR}/hoel.h
        ${INC_DIR}/h-private.h
        ${SRC_DIR}/hoel-simple-json.c
        ${SRC_DIR}/hoel-mariadb.c
        ${SRC_DIR}/hoel-pgsql.c
        ${SRC_DIR}/hoel-sqlite.c
        ${SRC_DIR}/hoel.c)

# dependencies

include(FindJansson)
set(JANSSON_MIN_VERSION 2.4)
find_package(Jansson ${JANSSON_MIN_VERSION} REQUIRED)
if (JANSSON_FOUND)
    set(LIBS ${JANSSON_LIBRARIES})
endif ()

option(WITH_SQLITE3 "Use SQLite3 library" ON)

if (WITH_SQLITE3)
	include(FindSQLite3)
	find_package(SQLite3 REQUIRED)
	if (SQLITE3_FOUND)
			set(LIBS ${LIBS} ${SQLITE3_LIBRARIES})
      add_definitions(-D_HOEL_SQLITE)
      include_directories(${SQLITE3_INCLUDE_DIR})
      set(LIBS ${LIBS} ${SQLITE3_LIBRARIES})
  else ()
      message("SQLite3 not found")
	endif ()
endif ()

option(WITH_MARIADB "Use MariaDB/MySQL library" ON)

if (WITH_MARIADB)
	include(FindMYSQL)
	find_package(MYSQL REQUIRED)
	if (MYSQL_FOUND)
			set(LIBS ${LIBS} ${MYSQL_LIBRARIES})
      add_definitions(-D_HOEL_MARIADB)
      include_directories(${MYSQL_INCLUDE_DIRS})
      set(LIBS ${LIBS} ${MYSQL_LIBRARIES})
  else ()
      message("MariaDB not found")
	endif ()
endif ()

option(WITH_PGSQL "Use PostgreSQL library" ON)

if (WITH_PGSQL)
  include(FindLibPQ)
	find_package(LibPQ REQUIRED)
  if(LIBPQ_FOUND)
			set(LIBS ${LIBS} ${LIBPQ_LIBRARIES})
      add_definitions(-D_HOEL_PGSQL)
      include_directories(${LIBPQ_INCLUDE_DIRS})
      set(LIBS ${LIBS} ${LIBPQ_LIBRARIES})
  else ()
      message("LibPQ not found")
  endif()
endif ()

if (NOT WITH_PGSQL AND NOT WITH_MARIADB AND NOT WITH_SQLITE3)
  MESSAGE(FATAL_ERROR "You must enable at least one databasse backend: Sqlite3, MariaDB/MySQL or PostgreSQL")
endif ()

# static library

option(BUILD_STATIC "Build static library." OFF)

if (BUILD_STATIC)
    add_library(hoel_static STATIC ${LIB_SRC})
    target_compile_definitions(hoel_static PUBLIC -DO_STATIC_LIBRARY)
    set_target_properties(hoel_static PROPERTIES
            OUTPUT_NAME libhoel)
endif ()

# shared library

add_library(hoel SHARED ${LIB_SRC})
set_target_properties(hoel PROPERTIES
        COMPILE_OPTIONS -Wextra
        PUBLIC_HEADER ${INC_DIR}/hoel.h
        VERSION "${LIBRARY_VERSION}"
        SOVERSION "${LIBRARY_SOVERSION}")
if (WIN32)
    set_target_properties(hoel PROPERTIES SUFFIX "-${LIBRARY_VERSION_MAJOR}.dll")
endif ()
target_link_libraries(hoel ${LIBS})

option(CHECK_YDER "Check Yder library." ON)

if (CHECK_YDER)
  set(Yder_FIND_QUIETLY ON) # force to find Yder quietly
  include(FindYder)
  find_package(Yder 1.1 QUIET) # try to find Yder
  if (NOT YDER_FOUND)
      include(DownloadProject)
      download_project(PROJ yder # ... otherwise, download archive
              URL "https://github.com/babelouest/yder/archive/v${YDER_VERSION_DOWNLOAD}.tar.gz"
              QUIET)
      add_subdirectory(${yder_SOURCE_DIR} ${yder_BINARY_DIR})
      include_directories(${yder_SOURCE_DIR}/include)
      include_directories(${orcania_SOURCE_DIR}/include)
      add_dependencies(hoel yder)
      add_dependencies(hoel orcania)
      set(HOEL_LIBRARIES yder orcania)
  endif ()
endif ()

# tests

option(BUILD_TESTING "Build the testing tree." OFF) # because we don not use include(CTest)

if (BUILD_TESTING)
    include(FindCheck)
    find_package(Check)
    if (CHECK_FOUND)
        if (NOT WIN32)
            include(FindSubunit)
            find_package(Subunit REQUIRED)
        endif ()

        enable_testing()

        set(CMAKE_CTEST_COMMAND ctest -V)

        set(TST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/test)
        set(LIBS hoel ${LIBS} ${CHECK_LIBRARIES})
        if (NOT WIN32)
            find_package(Threads REQUIRED)
            set(LIBS ${LIBS} ${SUBUNIT_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} m rt)
        endif ()

        set(TESTS
                str_test
                split_test
                memory_test)
        if (WITH_JANSSON)
            set(TESTS ${TESTS} jansson_test)
        endif ()

        configure_file(
                "${CMAKE_MODULE_PATH}/CTestCustom.cmake.in"
                "${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake"
                @ONLY)

        foreach (t ${TESTS})
            add_executable(${t} EXCLUDE_FROM_ALL ${TST_DIR}/${t}.c)
            target_include_directories(${t} PUBLIC ${TST_DIR})
            target_link_libraries(${t} PUBLIC ${LIBS})
            add_test(NAME ${t}
                    WORKING_DIRECTORY ${TST_DIR}
                    COMMAND ${t})
        endforeach ()
    endif ()
endif ()

# install target

option(INSTALL_HEADER "Install the header files" ON) # Install hoel.h or not

configure_file(libhoel.pc.in libhoel.pc @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libhoel.pc
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/pkgconfig)

set(TARGETS hoel)
if (BUILD_STATIC)
    set(TARGETS ${TARGETS} hoel_static)
endif ()

if (INSTALL_HEADER)
    install(TARGETS ${TARGETS}
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
            PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
    install(DIRECTORY examples/
            DESTINATION ${CMAKE_INSTALL_DOCDIR}/examples/ COMPONENT runtime)
    install(FILES README.md
            DESTINATION ${CMAKE_INSTALL_DOCDIR} COMPONENT runtime)
else ()
    install(TARGETS ${TARGETS}
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif ()

# uninstall target

if (NOT TARGET uninstall)
    configure_file(
            "${CMAKE_MODULE_PATH}/CMakeUninstall.cmake.in"
            "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
            IMMEDIATE @ONLY)
    add_custom_target(uninstall
            COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif ()

# packaging

set(CPACK_PACKAGE_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${LIBRARY_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${LIBRARY_VERSION_PATCH})

if (INSTALL_HEADER)
    set(PACKAGE_FILE_NAME
            "lib${CMAKE_PROJECT_NAME}-dev_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
else ()
    set(PACKAGE_FILE_NAME
            "lib${CMAKE_PROJECT_NAME}_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
endif ()
set(PACKAGE_IGNORED_FILES
        "${CMAKE_CURRENT_BINARY_DIR}/;/.git/;.gitignore;~$;${CPACK_SOURCE_IGNORE_FILES}")

set(CPACK_GENERATOR "TGZ;DEB")

set(CPACK_DEBIAN_PACKAGE_NAME "libhoel")
set(CPACK_DEBIAN_PACKAGE_MAINTAINER "mail@babelouest.org")
set(CPACK_DEBIAN_PACKAGE_DESCRIPTION ${PROJECT_DESCRIPTION})
set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://github.com/babelouest/hoel")
set(CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.14), libjansson4 (>= 2.4), liborcania (>= 1.2), libyder (>= 1.3), zlib1g (>= 1:1.1.4)")

if (WITH_SQLITE3)
	set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libsqlite3-0 (>= 3.5.9)")
endif ()

if (WITH_MARIADB)
	set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libmariadbclient18 (>= 5.5.36)")
endif ()

if (WITH_PGSQL)
	set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libpq5 (>= 9.0~)")
endif ()

set(CPACK_PACKAGE_FILE_NAME ${PACKAGE_FILE_NAME})

set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_PACKAGE_FILE_NAME ${PACKAGE_FILE_NAME})
set(CPACK_SOURCE_IGNORE_FILES ${PACKAGE_IGNORED_FILES})

include(CPack)

add_custom_target(dist_h
        COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

=== src/Makefile ===
#
# Hoel Framework
#
# Makefile used to build the software
#
# Copyright 2014-2018 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.	If not, see <http://www.gnu.org/licenses/>.
#
CC=gcc

ifndef DISABLE_SQLITE
FLAGS_SQLITE=-D_HOEL_SQLITE
LIBS_SQLITE=-lsqlite3
endif

ifndef DISABLE_MARIADB
FLAGS_MARIADB=-D_HOEL_MARIADB $(shell mysql_config --cflags)
LIBS_MARIADB=$(shell mysql_config --libs_r)
endif

ifndef DISABLE_POSTGRESQL
FLAGS_PGSQL=-D_HOEL_PGSQL -I/usr/include/postgresql/
LIBS_PGSQL=-lpq
endif

DESTDIR=/usr/local
CFLAGS+=-c -fPIC -Wall -I$(DESTDIR)/include $(FLAGS_SQLITE) $(FLAGS_MARIADB) $(FLAGS_PGSQL) -D_REENTRANT $(ADDITIONALFLAGS) $(CPPFLAGS)
LIBS=-L$(DESTDIR)/lib -lc -ljansson -lyder -lorcania $(LIBS_SQLITE) $(LIBS_PGSQL) $(LIBS_MARIADB)
OUTPUT=libhoel.so
VERSION=1.4.2

all: release

libhoel.so: hoel-sqlite.o hoel-mariadb.o hoel-pgsql.o hoel-simple-json.o hoel.o
	$(CC) -shared -fPIC -Wl,-soname,$(OUTPUT) -o $(OUTPUT).$(VERSION) hoel-sqlite.o hoel-mariadb.o hoel-pgsql.o hoel-simple-json.o hoel.o $(LIBS) $(LDFLAGS)
	ln -sf $(OUTPUT).$(VERSION) $(OUTPUT)

libhoel.a: hoel-sqlite.o hoel-mariadb.o hoel-pgsql.o hoel-simple-json.o hoel.o
	ar rcs libhoel.a hoel-sqlite.o hoel-mariadb.o hoel-pgsql.o hoel-simple-json.o hoel.o

hoel.o: hoel.c ../include/hoel.h
	$(CC) $(CFLAGS) hoel.c

hoel-sqlite.o: hoel-sqlite.c ../include/hoel.h
	$(CC) $(CFLAGS) hoel-sqlite.c

hoel-mariadb.o: hoel-mariadb.c ../include/hoel.h
	$(CC) $(CFLAGS) hoel-mariadb.c

hoel-pgsql.o: hoel-pgsql.c ../include/hoel.h
	$(CC) $(CFLAGS) hoel-pgsql.c

hoel-simple-json.o: hoel-simple-json.c ../include/hoel.h
	$(CC) $(CFLAGS) hoel-simple-json.c

clean:
	rm -f *.o *.so *.a $(OUTPUT) $(OUTPUT).*

install: all
	cp $(OUTPUT).$(VERSION) $(DESTDIR)/lib
	cp ../include/hoel.h $(DESTDIR)/include
	/sbin/ldconfig

static-install: static
	cp libhoel.a $(DESTDIR)/lib
	cp ../include/hoel.h $(DESTDIR)/include

uninstall:
	rm -f $(DESTDIR)/lib/$(OUTPUT) $(DESTDIR)/lib/libhoel.a
	rm -f $(DESTDIR)/lib/$(OUTPUT).*
	rm -f $(DESTDIR)/include/hoel.h

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: libhoel.so

release: ADDITIONALFLAGS=-O3

release: libhoel.so

static-debug: ADDITIONALFLAGS=-DDEBUG -g -O0

static-debug: libhoel.a

static: ADDITIONALFLAGS=-O3

static: libhoel.a

=== debian/changelog ===
hoel (1.4.2-1) unstable; urgency=medium

  * New upstream release
  * Install examples and README.md
  * debian/rules: use cmake as buildsystem
  * debian/copyright: add cmake scripts

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 28 Apr 2018 14:09:25 -0400

hoel (1.4.1-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <mail@babelouest.org>  Mon, 02 Apr 2018 09:59:11 -0400

=== debian/control ===
--- 
+++ 
@@ -3,6 +3,7 @@
 Priority: optional
 Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
 Uploaders: Thorsten Alteholz <debian@alteholz.de>
+          , Nicolas Mora <nicolas@babelouest.org>
 Build-Depends: debhelper (>= 11)
 	, liborcania-dev
 	, libyder-dev
@@ -10,12 +11,13 @@
 	, libsqlite3-dev
 	, libpq-dev
 	, libmariadbclient-dev
+  , cmake
 Standards-Version: 4.1.3
 Homepage: https://github.com/babelouest/hoel
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-iot/hoel.git
-Vcs-Git: https://anonscm.debian.org/git/debian-iot/hoel.git
+Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/hoel.git
+Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/hoel.git
 
-Package: libhoel1.3
+Package: libhoel1.4
 Architecture: any
 Section: libs
 Pre-Depends: ${misc:Pre-Depends}
@@ -28,7 +30,7 @@
 Package: libhoel-dev
 Architecture: any
 Section: libdevel
-Depends: libhoel1.3 (= ${binary:Version})
+Depends: libhoel1.4 (= ${binary:Version})
         , ${misc:Depends}
         , libjansson-dev
 	, liborcania-dev

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@ --buildsystem=cmake --builddirectory=build

override_dh_auto_install:
	echo dh_auto_install

override_dh_auto_configure:
	dh_auto_configure -- $(ARGS) --no-warn-unused-cli
	dh_installexamples

## hoel 1.4.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,14 +24,16 @@
 # library info
 
 set(PROJECT_DESCRIPTION "C Database abstraction library with json based language")
+set(PROJECT_HOMEPAGE_URL "https://github.com/babelouest/hoel/")
 set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/hoel/issues")
-
 set(LIBRARY_VERSION_MAJOR "1")
 set(LIBRARY_VERSION_MINOR "4")
-set(LIBRARY_VERSION_PATCH "2")
+set(LIBRARY_VERSION_PATCH "4")
+set(YDER_VERSION_DOWNLOAD "1.4.2")
+
+set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(LIBRARY_SOVERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")
-set(YDER_VERSION_DOWNLOAD "1.3.3")
 
 # cmake modules
 
@@ -129,6 +131,18 @@
   MESSAGE(FATAL_ERROR "You must enable at least one databasse backend: Sqlite3, MariaDB/MySQL or PostgreSQL")
 endif ()
 
+set (PKGCONF_REQ "")
+set (PKGCONF_REQ_PRIVATE "liborcania, libyder")
+if (WITH_SQLITE3)
+  set (PKGCONF_REQ_PRIVATE "${PKGCONF_REQ_PRIVATE}, sqlite3")
+endif ()
+if (WITH_MARIADB)
+  set (PKGCONF_REQ_PRIVATE "${PKGCONF_REQ_PRIVATE}, mariadb")
+endif ()
+if (WITH_PGSQL)
+  set (PKGCONF_REQ_PRIVATE "${PKGCONF_REQ_PRIVATE}, libpq")
+endif ()
+
 # static library
 
 option(BUILD_STATIC "Build static library." OFF)
@@ -137,7 +151,7 @@
     add_library(hoel_static STATIC ${LIB_SRC})
     target_compile_definitions(hoel_static PUBLIC -DO_STATIC_LIBRARY)
     set_target_properties(hoel_static PROPERTIES
-            OUTPUT_NAME libhoel)
+            OUTPUT_NAME hoel)
 endif ()
 
 # shared library
@@ -175,9 +189,9 @@
 
 # tests
 
-option(BUILD_TESTING "Build the testing tree." OFF) # because we don not use include(CTest)
-
-if (BUILD_TESTING)
+option(BUILD_HOEL_TESTING "Build the testing tree." OFF) # because we don not use include(CTest)
+
+if (BUILD_HOEL_TESTING)
     include(FindCheck)
     find_package(Check)
     if (CHECK_FOUND)
@@ -191,19 +205,13 @@
         set(CMAKE_CTEST_COMMAND ctest -V)
 
         set(TST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/test)
-        set(LIBS hoel ${LIBS} ${CHECK_LIBRARIES})
+        set(LIBS hoel yder orcania ${LIBS} ${CHECK_LIBRARIES})
         if (NOT WIN32)
             find_package(Threads REQUIRED)
             set(LIBS ${LIBS} ${SUBUNIT_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} m rt)
         endif ()
 
-        set(TESTS
-                str_test
-                split_test
-                memory_test)
-        if (WITH_JANSSON)
-            set(TESTS ${TESTS} jansson_test)
-        endif ()
+        set(TESTS core)
 
         configure_file(
                 "${CMAKE_MODULE_PATH}/CTestCustom.cmake.in"
@@ -228,7 +236,7 @@
 configure_file(libhoel.pc.in libhoel.pc @ONLY)
 
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libhoel.pc
-        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/pkgconfig)
+        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
 
 set(TARGETS hoel)
 if (BUILD_STATIC)
@@ -279,9 +287,20 @@
 set(PACKAGE_IGNORED_FILES
         "${CMAKE_CURRENT_BINARY_DIR}/;/.git/;.gitignore;~$;${CPACK_SOURCE_IGNORE_FILES}")
 
+set(CPACK_PACKAGE_NAME "libhoel")
+set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Database abstraction library in C")
 set(CPACK_GENERATOR "TGZ;DEB")
-
-set(CPACK_DEBIAN_PACKAGE_NAME "libhoel")
+set(CPACK_PACKAGE_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
+set(CPACK_PACKAGE_VERSION_MINOR ${LIBRARY_VERSION_MINOR})
+set(CPACK_PACKAGE_VERSION_PATCH ${LIBRARY_VERSION_PATCH})
+
+option(BUILD_RPM "Build a RPM for your system" OFF)
+if (BUILD_RPM)
+  set(CPACK_GENERATOR "TGZ;DEB;RPM")
+  set(CPACK_RPM_PACKAGE_LICENSE "LGPL")
+  set(CPACK_RPM_PACKAGE_URL "http://babelouest.github.io/hoel/")
+endif ()
+
 set(CPACK_DEBIAN_PACKAGE_MAINTAINER "mail@babelouest.org")
 set(CPACK_DEBIAN_PACKAGE_DESCRIPTION ${PROJECT_DESCRIPTION})
 set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://github.com/babelouest/hoel")

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 # Makefile used to build all programs
 #
-# Copyright 2014-2015 Nicolas Mora <mail@babelouest.org>
+# Copyright 2014-2018 Nicolas Mora <mail@babelouest.org>
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the MIT License
@@ -18,6 +18,7 @@
 EXAMPLE_LOCATION=./examples
 TEST_LOCATION=./test
 
+.NOTPARALLEL:
 all: libhoel.so example_sqlite3 example_mariadb example_pgsql
 
 debug:

=== examples/Makefile ===
--- 
+++ 
@@ -14,9 +14,10 @@
 # GNU GENERAL PUBLIC LICENSE for more details.
 #
 CC=gcc
-CFLAGS=-c -Wall -D_REENTRANT -I$(PREFIX)/include $(ADDITIONALFLAGS)
+HOEL_INCLUDE=../include
+CFLAGS=-c -Wall -I$(HOEL_INCLUDE) -D_REENTRANT -I$(PREFIX)/include $(ADDITIONALFLAGS)
 HOEL_LOCATION=../src
-LIBS=-lc -lhoel -ljansson -lyder -L$(HOEL_LOCATION)
+LIBS=-lc -lhoel -ljansson -lyder -lorcania -L$(HOEL_LOCATION)
 ADDITIONALFLAGS=-O3
 
 all: libhoel.so example_sqlite3 example_mariadb example_pgsql example_mariadb_json

=== src/Makefile ===
--- 
+++ 
@@ -35,11 +35,12 @@
 LIBS_PGSQL=-lpq
 endif
 
+HOEL_INCLUDE=../include
 DESTDIR=/usr/local
-CFLAGS+=-c -fPIC -Wall -I$(DESTDIR)/include $(FLAGS_SQLITE) $(FLAGS_MARIADB) $(FLAGS_PGSQL) -D_REENTRANT $(ADDITIONALFLAGS) $(CPPFLAGS)
+CFLAGS+=-c -fPIC -Wall -I$(HOEL_INCLUDE) -I$(DESTDIR)/include $(FLAGS_SQLITE) $(FLAGS_MARIADB) $(FLAGS_PGSQL) -D_REENTRANT $(ADDITIONALFLAGS) $(CPPFLAGS)
 LIBS=-L$(DESTDIR)/lib -lc -ljansson -lyder -lorcania $(LIBS_SQLITE) $(LIBS_PGSQL) $(LIBS_MARIADB)
 OUTPUT=libhoel.so
-VERSION=1.4.2
+VERSION=1.4.4
 
 all: release
 
@@ -50,19 +51,19 @@
 libhoel.a: hoel-sqlite.o hoel-mariadb.o hoel-pgsql.o hoel-simple-json.o hoel.o
 	ar rcs libhoel.a hoel-sqlite.o hoel-mariadb.o hoel-pgsql.o hoel-simple-json.o hoel.o
 
-hoel.o: hoel.c ../include/hoel.h
+hoel.o: hoel.c $(HOEL_INCLUDE)/hoel.h
 	$(CC) $(CFLAGS) hoel.c
 
-hoel-sqlite.o: hoel-sqlite.c ../include/hoel.h
+hoel-sqlite.o: hoel-sqlite.c $(HOEL_INCLUDE)/hoel.h
 	$(CC) $(CFLAGS) hoel-sqlite.c
 
-hoel-mariadb.o: hoel-mariadb.c ../include/hoel.h
+hoel-mariadb.o: hoel-mariadb.c $(HOEL_INCLUDE)/hoel.h
 	$(CC) $(CFLAGS) hoel-mariadb.c
 
-hoel-pgsql.o: hoel-pgsql.c ../include/hoel.h
+hoel-pgsql.o: hoel-pgsql.c $(HOEL_INCLUDE)/hoel.h
 	$(CC) $(CFLAGS) hoel-pgsql.c
 
-hoel-simple-json.o: hoel-simple-json.c ../include/hoel.h
+hoel-simple-json.o: hoel-simple-json.c $(HOEL_INCLUDE)/hoel.h
 	$(CC) $(CFLAGS) hoel-simple-json.c
 
 clean:
@@ -70,12 +71,12 @@
 
 install: all
 	cp $(OUTPUT).$(VERSION) $(DESTDIR)/lib
-	cp ../include/hoel.h $(DESTDIR)/include
+	cp $(HOEL_INCLUDE)/hoel.h $(DESTDIR)/include
 	/sbin/ldconfig
 
 static-install: static
 	cp libhoel.a $(DESTDIR)/lib
-	cp ../include/hoel.h $(DESTDIR)/include
+	cp $(HOEL_INCLUDE)/hoel.h $(DESTDIR)/include
 
 uninstall:
 	rm -f $(DESTDIR)/lib/$(OUTPUT) $(DESTDIR)/lib/libhoel.a

=== debian/changelog ===
hoel (1.4.4-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <nicolas@babelouest.org>  Fri, 12 Oct 2018 18:27:04 -0400

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
 	, libpq-dev
 	, libmariadbclient-dev
   , cmake
-Standards-Version: 4.1.3
+Standards-Version: 4.2.1
 Homepage: https://github.com/babelouest/hoel
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/hoel.git
 Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/hoel.git
